indexing

   title:       "Abstract container for the format string types";
   cluster:     "format/science [format/science]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Andy Malakov  (andy@eiffel.ru) and";
   original:    08,Sep,1995;
   version:     1.0;
   last_change:
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "fmt_tab.e"

class FORMAT_TABLE [ G -> FORMAT_TABLE_ELEMENT ]

   inherit
      ARRAY [ G ]
         rename make as array_make
         end;

   creation
      make

   feature

      -- Attention: All methods affect this attributes
      found : BOOLEAN
      found_item : G
      found_index : INTEGER

      ----------------------------------------------------------------
      make is
         do
            array_make ( 1, 0 )
         end

   -------------------------------------------------------------------
   feature  -- search
   -------------------------------------------------------------------
      search ( g : G ) is
         require
            non_void_parameter : g /= Void
         do
            from
               found_index := lower; found := false
            until
               found or else found_index  > upper
            loop
               if g.is_equal ( item ( found_index ) ) then
                  found_item := item ( found_index )
                  found := true
               else
                  found_index := found_index + 1
               end
            end -- loop
         end -- search

      ----------------------------------------------------------------
      search_by_example ( sample : ANY ) is
         require
            non_void_parameter : sample /= Void
         do
            from
               found_index := lower; found := false
            until
               found or else found_index > upper
            loop
               if sample.conforms_to ( item (found_index).sample ) then
                  found_item := item(found_index)
                  found := true
               else
                  found_index := found_index  + 1
               end
            end -- loop
         end -- search_by_example
   -------------------------------------------------------------------
   feature  -- add/modify
   -------------------------------------------------------------------
      add, frozen fmt_add ( new_g : G ) is
         require
            non_Void_new_item : new_g /= Void
         do
            force ( new_g, size + 1 )
         ensure
            size > 0
         end -- add

      ----------------------------------------------------------------
      contain ( g : G ) : BOOLEAN is
         do
            search ( g )
            Result := found
         end

end -- class FORMAT_TABLE
